summaryrefslogtreecommitdiff
path: root/tests/misc/printf-quote.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/printf-quote.sh')
-rwxr-xr-xtests/misc/printf-quote.sh57
1 files changed, 57 insertions, 0 deletions
diff --git a/tests/misc/printf-quote.sh b/tests/misc/printf-quote.sh
new file mode 100755
index 000000000..73fc404b8
--- /dev/null
+++ b/tests/misc/printf-quote.sh
@@ -0,0 +1,57 @@
+#!/bin/sh
+# tests for printf %q
+
+# Copyright (C) 2015 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+prog='env printf'
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ printf
+
+# Equivalent output to ls --quoting=shell-escape
+env printf '%q\n' '' "'" a 'a b' '~a' 'a~' "$(env printf %b 'a\r')" > out
+cat <<\EOF > exp || framework_failure_
+''
+''\'''
+a
+'a b'
+'~a'
+a~
+'a'$'\r'
+EOF
+compare exp out || fail=1
+
+unset LC_ALL
+f=$LOCALE_FR_UTF8
+: ${LOCALE_FR_UTF8=none}
+if test "$LOCALE_FR_UTF8" != "none"; then
+ (
+ #printable multi-byte
+ LC_ALL=$f env printf '%q\n' 'áḃç' > out
+ #non-printable multi-byte
+ LC_ALL=$f env printf '%q\n' "$(LC_ALL=$f env printf '\u0378')" >> out
+ #printable multi-byte in C locale
+ LC_ALL=C env printf '%q\n' 'áḃç' >> out
+ )
+ cat <<\EOF > exp || framework_failure_
+áḃç
+''$'\315\270'
+''$'\303\241\341\270\203\303\247'
+EOF
+ compare exp out || fail=1
+fi
+
+Exit $fail